using System;
using System.Collections.Generic;
using System.Linq;
using MacGruber;
using UnityEngine;
using Object = System.Object;

namespace CheesyFX
{
    public class BJHelper : MonoBehaviour
    {
        public static HashSet<Penetrator> penetrators = new HashSet<Penetrator>();
        private static Penetrator closest;
        public static GameObject triggerGO;
        private static CapsuleCollider trigger;
        public static BJHelper singleton;
        public static JSONStorableBool enabledJ = new JSONStorableBool("Pre BJ Reactions Enabled", true);
        private static JSONStorableBool openMouth = new JSONStorableBool("Open Mouth", true);
        private static JSONStorableBool morphLips = new JSONStorableBool("Morph Lips", true);
        private static JSONStorableBool morphTongue = new JSONStorableBool("Morph Tongue", true);
        public static JSONStorableFloat distance = new JSONStorableFloat("Distance", 0f, 0f, .15f, true, false);
        public static JSONStorableFloat speed = new JSONStorableFloat("Speed", 0f, -1f, 1f, true, false);
        public static JSONStorableString info = new JSONStorableString("info", "");
        // private static JSONStorableBool debug = new JSONStorableBool("Debug", false, val => trigger.gameObject.GetComponent<Renderer>().enabled = val);

        private static DAZBone tongue;
        public static MyJSONStorableVector3 tongueRot = new MyJSONStorableVector3("tongueRot", new Vector3(), new Vector3(-45f, -45f, -45f), new Vector3(45f, 45f, 45f), val =>
            tongue.transform.localRotation = Quaternion.Euler(val));
        public static MyJSONStorableVector3 tonguePos = new MyJSONStorableVector3("tonguePos", new Vector3(), new Vector3(-.05f, -.05f, -.05f), new Vector3(.05f, .05f, .05f), val =>
            tongue.transform.localPosition = val);

        private static MyJSONStorableVector3 offset =
            new MyJSONStorableVector3("Offset", new Vector3(), new Vector3(), new Vector3(.1f, .1f, .1f), Offset);
        
        private float lastDistance;
        public static Transform throatTrigger;
        public static Transform lipTrigger;
        // private static List<LerpingMorph> morphs = new List<LerpingMorph>();
        private static LerpingMorph mouthOpen;
        private static LerpingMorph mouthNarrow;
        private static LerpingMorph mouthBlow;
        private static LerpingMorph tongueOut;
        private static LerpingMorph tongueUp;

        private void Start()
        {
            singleton = this;
            trigger = FillMeUp.throat.proximityTrigger;
            trigger.gameObject.AddComponent<BJHelperTrigger>();
            foreach (var collider in FillMeUp.atom.GetComponentsInChildren<Collider>())
            {
                Physics.IgnoreCollision(trigger, collider);
            }
            foreach (var hand in FillMeUp.atom.rigidbodies.Where(x => x.name.Contains("Hand")))
            {
                foreach (var col in hand.GetComponentsInChildren<Collider>())
                {
                    Physics.IgnoreCollision(trigger, col, false);
                }
            }
            mouthBlow = gameObject.AddComponent<LerpingMorph>().Init(ReadMyLips.packageUid+"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/BJ/BL_Mouth Blow.vmi");
            // morphs.Add(gameObject.AddComponent<LerpingMorph>().Init(ReadMyLips.packageUid+"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/BJ/BL_Blow Job.vmi"));
            // morphs.Add(gameObject.AddComponent<LerpingMorph>().Init(ReadMyLips.packageUid+"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/BJ/BL_AAG9 Mouth Open.vmi"));
            // morphs.Add(gameObject.AddComponent<LerpingMorph>().Init(ReadMyLips.packageUid+"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/BJ/BL_AAG9 Mouth Open Wide.vmi"));
            // morphs.Add(gameObject.AddComponent<LerpingMorph>().Init(ReadMyLips.packageUid+"Mouth Open Wide 2"));
            // morphs.Add(gameObject.AddComponent<LerpingMorph>().Init(ReadMyLips.packageUid+"Mouth Narrow"));
            mouthOpen = gameObject.AddComponent<LerpingMorph>().Init("Mouth Open Wide 2");
            mouthNarrow = gameObject.AddComponent<LerpingMorph>().Init(ReadMyLips.packageUid+"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/BJ/BL_MouthNarrow.vmi");
            tongueOut = gameObject.AddComponent<LerpingMorph>().Init("Tongue In-Out");
            tongueUp = gameObject.AddComponent<LerpingMorph>().Init("Tongue Raise-Lower");

            // FillMeUp.atom.GetComponentsInChildren<DAZBone>().ToList().ForEach(x =>
            // {
            //     if (x.name.ToLower().Contains("tongue")) x.name.Print();
            // });
            tongue = FillMeUp.atom.GetComponentsInChildren<DAZBone>().First(x => x.name == "tongue04");

            enabledJ.setCallbackFunction += SetActive;
            enabled = false;
        }

        private void SetActive(bool val)
        {
            enabled = false;
            mouthOpen.target = mouthBlow.target = 0f;
            mouthNarrow.target = 0f;
            tongueOut.target = 1f;
            info.val = val? "":"Disabled";
        }

        private void OnEnable()
        {
            // distance.val = penetrators.Min(x => GetDistance(x.tip));
            if (!enabledJ.val)
            {
                enabled = false;
                return;
            }
            GetClosestPenetrator();
            info.val = closest.atom.name;
        }

        private void OnDestroy()
        {
            // Destroy(triggerGO);
            mouthOpen.morphVal = 0f;
            mouthNarrow.morphVal = 0f;
        }

        private void OnDisable()
        {
            // "OnDisable".Print();
            distance.val = lastDistance = 0f;
            speed.val = 0f;
            if (FillMeUp.throat.isPenetrated)
            {
                mouthOpen.target = FillMeUp.throat.penetrator.width;
                mouthBlow.target = .5f;
                info.val = enabledJ.val? $"Paused: Sucking {FillMeUp.throat.penetrator.atom.name}":"Disabled";
            }
            else
            {
                mouthOpen.target = mouthBlow.target = 0f;
                info.val = enabledJ.val? "":"Disabled";
            }
            mouthNarrow.target = 0f;
            tongueOut.target = 1f;
        }

        private void Update()
        {
            // distance.val = penetrators.Min(x => GetDistance(x.tip));
            GetClosestPenetrator();
            // info.val = closest.tipCollider.name;
            GetSpeed();
            lastDistance = distance.val;
            mouthOpen.quicknessIn = mouthNarrow.quicknessIn = mouthBlow.quicknessIn = tongueUp.quicknessIn = 500f * (distance.val-.1f) * (distance.val-.1f) * 50f*speed.val;
            mouthOpen.quicknessOut = mouthNarrow.quicknessOut = mouthBlow.quicknessOut = tongueUp.quicknessOut = tongueOut.quicknessIn = 1f + 4f * distance.val;
            tongueOut.quicknessOut = mouthOpen.quicknessIn * .25f;
            
            var target = closest.width - closest.width * 10f * (distance.val - .03f);
            if (speed.val > .005f)
            {
                mouthOpen.target = target;
                mouthNarrow.target = target * .7f;
                mouthBlow.target = Mathf.Lerp(.5f, 0f, distance.val*20f);
                tongueOut.target = -1f;
                tongueUp.target = .15f;
            }
            else
            {
                mouthOpen.target = 0f;
                mouthNarrow.target = 0f;
                mouthBlow.target = 0f;
                tongueOut.target = 1f;
                tongueUp.target = 0f;
            }
            
        }

        private void GetClosestPenetrator()
        {
            distance.val = 10f;
            float dist;
            foreach (var penetrator in penetrators)
            {
                dist = GetDistance(penetrator.tip);
                if (dist < distance.val)
                {
                    distance.val = dist;
                    closest = penetrator;
                }
            }
        }

        private float GetDistance(Transform point)
        {
            return Mathf.Max(0f, Vector3.Dot(throatTrigger.position - point.position, trigger.transform.up));
        }

        private void GetSpeed()
        {
            var newSpeed = (lastDistance - distance.val) / Time.fixedDeltaTime;
            speed.val = Mathf.Lerp(speed.val, newSpeed, 5f * Time.fixedDeltaTime);
        }
        
        public static void CreateUI(List<object> UIElements)
        {
            distance.CreateUI(UIElements);
            speed.CreateUI(UIElements, rightSide:true);
            enabledJ.CreateUI(UIElements);
            var infoLine = Utils.SetupInfoOneLine(FillMeUp.singleton, info, false);
            UIElements.Add(infoLine);
            // openMouth.CreateUI(UIElements);
            // morphLips.CreateUI(UIElements);
            // morphTongue.CreateUI(UIElements);
            FillMeUp.singleton.CreateStaticInfo(
                "This feature drives facial reactions based on the distance and speed at which a penetrator is approaching the mouth. It is independent of the auto BJ feature of FillMeUp.",
                170f, UIElements, true);
        }
        
        public static void Offset(Vector3 v3)
        {
            // triggerGO.transform.localPosition = lipTrigger.InverseTransformDirection(triggerGO.transform.TransformDirection(v3 + new Vector3(0f, .04f, -.04f)));
            triggerGO.transform.localPosition = Quaternion.Euler(15f, 0f, 0f) * (v3 + new Vector3(0f, -.01f, .04f));
        }
    }
}